/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { Flattener } from "igniteui-react-core";
/**
 * @hidden
 */
export let BollingerBandsOverlay = /*@__PURE__*/ (() => {
    class BollingerBandsOverlay extends FinancialOverlay {
        bi() {
            return new BollingerBandsOverlay();
        }
        constructor() {
            super();
            this.aaz = 0;
            this.aa0 = 0;
            this.aax = new List$1(Number_$type, 0);
            this.aay = new List$1(Number_$type, 0);
            this.ab = BollingerBandsOverlay.$;
            this.w1 = new CategoryFrame(4);
            this.w3 = new CategoryFrame(4);
            this.wz = new CategoryFrame(4);
        }
        q4(a, b, c, d) {
            if (this.yg().contains(b)) {
                this.aar = false;
            }
            super.q4(a, b, c, d);
            switch (b) {
                case BollingerBandsOverlay.$$p[1]:
                    this.aar = false;
                    this.rm(false);
                    break;
                case BollingerBandsOverlay.$$p[0]:
                    this.rm(false);
                    break;
            }
        }
        aas() {
            this.aax.clear();
            this.aay.clear();
            let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.yf), this.aa2));
            let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.yf), this.aa2));
            this.aa0 = 1.7976931348623157E+308;
            this.aaz = -1.7976931348623157E+308;
            let c = true;
            let d = true;
            let e = this.aa1;
            while (c || d) {
                if (a.moveNext()) {
                    this.aax.add(a.current);
                }
                else {
                    c = false;
                }
                if (b.moveNext()) {
                    this.aay.add(b.current);
                }
                else {
                    d = false;
                }
                if (c && d) {
                    this.aa0 = Math.min(this.aa0, a.current - b.current * e);
                    this.aaz = Math.max(this.aaz, a.current + b.current * e);
                }
            }
            return true;
        }
        ax(a) {
            if (this.aax == null || this.aay == null || a == null || this.dl == null || a != this.xg) {
                return null;
            }
            let b = new AxisRange(this.aa0, this.aaz);
            return b;
        }
        z3(a, b) {
            super.z3(a, b);
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.wx;
            let g = this.xg;
            let h = new ScalerParams(0, c, d, f.ch, e);
            let i = new ScalerParams(0, c, d, g.ch, e);
            a.f.clear();
            a.n.clear();
            a.q.clear();
            let j = typeCast(ISortingAxis_$type, this.wx);
            if (j != null && j.i$b.count != this.dl.count) {
                return;
            }
            let k = 0;
            k = this.yo(c, d, e);
            if (!this.aar) {
                this.aar = this.aas();
                if (this.xg != null) {
                    this.xg.c2(true);
                }
            }
            i.b = this.iw();
            let l = this.wx.en(2, h) - this.wx.en(1, h);
            for (let m = b.b0.c; m <= b.b0.d; ++m) {
                let n;
                if (j == null) {
                    n = b.b0.getBucket(m);
                }
                else {
                    let o = j.i$b._inner[m];
                    let p = j.i$d(o);
                    let q = this.aax._inner[m];
                    let r = this.aay._inner[m];
                    let s = q;
                    let t = r;
                    let u = p;
                    let v = 1;
                    while (m < b.b0.d) {
                        o = j.i$b._inner[m + 1];
                        u = j.i$d(o);
                        if (u - p > l) {
                            break;
                        }
                        m++;
                        s += this.aax._inner[m];
                        t += this.aay._inner[m];
                        v++;
                    }
                    s /= v;
                    t /= v;
                    let w = s - t * this.aa1;
                    let x = s;
                    let y = s + t * this.aa1;
                    let z = NaN;
                    if (!isNaN_(p)) {
                        z = this.wx.ek(p, h);
                    }
                    n = [z, w, x, y];
                }
                let aa = Math.max(1, l);
                if (!isNaN_(n[0]) && m * aa >= this.aat) {
                    if (this.wx != null && typeCast(ISortingAxis_$type, this.wx) !== null) {
                        n[0] = n[0] + k;
                    }
                    else {
                        n[0] = f.ek(n[0], h) + k;
                    }
                    n[1] = g.ek(n[1], i);
                    n[2] = g.ek(n[2], i);
                    n[3] = g.ek(n[3], i);
                    a.f.add(n);
                }
            }
        }
        o2(a, b) {
            super.o2(a, b);
            let c = b;
            if (c != null) {
                c.b7();
            }
        }
        i3(a, b, c) {
            if (this.aax == null) {
                return super.i3(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.ct);
            let e = this.yo(this.ct.by, this.ct.bx, d);
            let f = new ScalerParams(0, this.ct.by, this.ct.bx, this.wx.ch, d);
            f.c = this.c9.v0;
            return this.i5(this.aax, a, this.wx, f, e, runOn(this, this.yn), b, c);
        }
        j8(a, b) {
            if (this.aax == null) {
                return super.j8(a, b);
            }
            return this.j9(a, b, this.wx, runOn(this, this.yn), this.aax);
        }
        j6(a, b) {
            if (this.aax == null) {
                return super.j6(a, b);
            }
            return this.j7(a, b, this.wx, runOn(this, this.yn), this.aax);
        }
        hc(a, b, c) {
            let d = super.hc(a, b, c);
            if (!this.x6(this.yg())) {
                d = false;
            }
            return d;
        }
        z5(a, b) {
            super.z5(a, b);
            let c = typeCast(BollingerBandsOverlayView.$, b);
            let d = this.getEffectiveViewport1(b);
            if (b.b3(a)) {
                c.b7();
                let e = a.f.count;
                let f = (g) => a.f._inner[g][0];
                let g = (h) => a.f._inner[e - 1 - h][0];
                let h = (i) => a.f._inner[i][1];
                let i = (j) => a.f._inner[j][2];
                let j = (k) => a.f._inner[e - 1 - k][3];
                c.b8(e, f, g, h, i, j);
                b.b5(a);
            }
            this.w6.a2(this, this.x5(), runOn(this, this.wp), this.yu(b), this.yw(b));
            let k = false;
            let l = this.w6.b;
            let m = a.f;
            let n = this.dl.count;
            if (l != null) {
                k = true;
            }
            if (k) {
                let o = new ScalerParams(0, b.by, b.bx, this.wx.ch, d);
                this.z2(m, -1, n, this.wx, o, b.q, -1);
            }
            let p = c.cf;
            let q = c.cg;
            let r = c.ch;
            let s = c.ca;
            this.w6.ad(q, true, false, true, true);
            this.w6.an = null;
            this.w6.am = null;
            this.w6.ad(p, true, false, false, true);
            this.w6.ad(r, true, false, false, true);
            this.w6.ad(s, false, true, false, false);
            s._opacity = this.w6.j * this.h7;
        }
        cq() {
            return new BollingerBandsOverlayView(this);
        }
        qw(a) {
            super.qw(a);
            this.aaw = typeCast(BollingerBandsOverlayView.$, a);
        }
        yx() {
            return 3;
        }
        iw() {
            return Series.iy(this.aax, null);
        }
    }
    BollingerBandsOverlay.$t = /*@__PURE__*/ markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:aa1:aa5', [1, 2], 'Period:aa2:aa6', [1, 14]]);
    return BollingerBandsOverlay;
})();
/**
 * @hidden
 */
export let BollingerBandsBucketCalculator = /*@__PURE__*/ (() => {
    class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.a.b2.dl.count - 1);
            if (b <= c) {
                let d = this.f.b6.aa1;
                let e = 0;
                let f = 0;
                let g = 0;
                for (let h = b; h <= c; ++h) {
                    if (!isNaN_(this.f.b6.aax._inner[h]) && !isNaN_(this.f.b6.aay._inner[h])) {
                        e += this.f.b6.aax._inner[h];
                        f += this.f.b6.aay._inner[h];
                        ++g;
                    }
                }
                if (g > 0) {
                    e = e / g;
                    f = f / g;
                    return [0.5 * (b + c), e - f * d, e, e + f * d];
                }
            }
            return [NaN, NaN, NaN, NaN];
        }
    }
    BollingerBandsBucketCalculator.$t = /*@__PURE__*/ markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
})();
/**
 * @hidden
 */
export let BollingerBandsOverlayView = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b6 = null;
            this.cb = new Polygon();
            this.ci = new Polyline();
            this.cj = new Polyline();
            this.ck = new Polyline();
            this.b9 = new Polygon();
            this.cc = new Polyline();
            this.cd = new Polyline();
            this.ce = new Polyline();
            this.b6 = a;
        }
        au() {
            super.au();
            if (!this.q) {
            }
        }
        b1() {
            return new BollingerBandsBucketCalculator(this);
        }
        b8(a, b, c, d, e, f) {
            for (let g of fromEnum(Flattener.d(a, b, d, this.e.ib))) {
                this.cb.an.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.ci.an.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
            for (let h of fromEnum(Flattener.d(a, b, e, this.e.ib))) {
                this.cj.an.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
            for (let i of fromEnum(Flattener.d(a, c, f, this.e.ib))) {
                this.cb.an.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ck.an.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
            this.as();
        }
        b7() {
            this.cb.an.clear();
            this.ci.an.clear();
            this.cj.an.clear();
            this.ck.an.clear();
            this.as();
        }
        get ca() {
            return this.cb;
        }
        get cf() {
            return this.ci;
        }
        get cg() {
            return this.cj;
        }
        get ch() {
            return this.ck;
        }
        be() {
            super.be();
            this.b9.an = this.cb.an;
            this.cc.an = this.ci.an;
            this.cd.an = this.cj.an;
            this.ce.an = this.ck.an;
            let a = this.br();
            this.b9._fill = a;
            this.b9._opacity = 1;
            this.cc._stroke = a;
            this.cc.ad = this.e.ic + 3;
            this.cd._stroke = a;
            this.cd.ad = this.e.ic + 3;
            this.ce._stroke = a;
            this.ce.ad = this.e.ic + 3;
        }
        a8(a, b) {
            super.a8(a, b);
            if (a.d) {
                if (b) {
                    a.u(this.b9);
                    a.v(this.cc);
                    a.v(this.cd);
                    a.v(this.ce);
                }
                else {
                    a.u(this.cb);
                    a.v(this.ci);
                    a.v(this.cj);
                    a.v(this.ck);
                }
            }
        }
        an(a) {
            super.an(a);
            this.e.bb.exportPolygonData(a, this.cb, "FillShape", ["Fill"]);
            this.e.bb.exportPolylineData(a, this.ci, "BottomLine", ["Lower", "Main"]);
            this.e.bb.exportPolylineData(a, this.cj, "CentralLine", ["Central"]);
            this.e.bb.exportPolylineData(a, this.ck, "TopLine", ["Upper"]);
        }
    }
    BollingerBandsOverlayView.$t = /*@__PURE__*/ markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
})();
